#include "any2tfb.h"
#include<string.h>
#include<stdlib.h>

char *emalloc(unsigned);

typedef struct Hensu{   /* $BJQ?t%j%9%H8!:w@lMQ9=B$BN(B */
  char *name;     /* $BJQ?tL>(B */
  struct Hensu *next;
}Hensu;

Symbol *makesymbol(short type,char *value) /* make symbol */
{
  Symbol *sp;   /* symbol pointer */
  Symbol **childp;  /* pointer to Symbol pointer */
  sp=(Symbol *)emalloc(sizeof(Symbol));
  sp->type=type;
  if(value!=NULL){
	sp->value=(char *)emalloc(strlen(value)+1);   /* +1 for '\0' */
	strcpy(sp->value,value);
  }
  else
	sp->value=NULL;    /* $B0l1~(B */
  childp=(Symbol **)emalloc(CHILD*sizeof(Symbol *)); /* Symbol$B$X$N(B */
  sp->childp = childp;   /* $B%]%$%s%?G[Ns$X$N%]%$%s%?(B  */
  sp->number=0;        /* $B;R6!$N?t$O:G=i$O#0(B */
}

char *emalloc(unsigned n)    /* check return from malloc and initialize */
{
  int i;
  char *p;
  p=(char *)malloc(n);
  if(p==0)
	execerror("out of memory",(char *)0);
  for(i=0;i<n;i++)
	*(p+i)=0;          /* $B=i4|2=(B */
  return p;
}


/*
  $B$3$3$h$j2<$OJQ?t$N4IM}$r$9$k4X?t72(B
  $B9=B$BN%a%s%P(B name : $BL>A0(B
               next  : $B<!$X$N%]%$%s%?(B
*/


static Hensu *hensulist=0;   /* $BITDj85$N%F!<%V%k!'DL>o$N%j%9%H(B */


/*
  $BJQ?t%j%9%H$N8!:w(B
*/
int lookup(char *name)
{
  Hensu *hp;
  for(hp=hensulist;hp!=(Hensu *)0;hp=hp->next)
	if(strcmp(hp->name,name)==0)
	  return 1;     /* found */
  return 0;       /* not found */
}


/*
  $BJQ?t$NDI2C(B
*/
void install(char *name)
{
  Hensu *hp;
  hp=(Hensu *)emalloc(sizeof(Hensu));
  hp->name=(char *)emalloc(strlen(name)+1);  /* +1 for '\0' */
  strcpy(hp->name,name);
  hp->next=hensulist;   /* put at front of list  */
  hensulist=hp;
}


/*
  $B%j%9%H$+$i(Bvar$B$H0lCW$9$k%a%s%P$r;}$D9=B$BN$r:o=|(B
*/

void var_remove(char *var)
{
  Hensu *hp;     
  if(strcmp(var,hensulist->name)==0){      /*$B@hF,%a%s%P#1$D$G(BHIT$B$7$?$H$-(B  */
	hensulist=hensulist->next;
	return ;
  }
  for(hp=hensulist;hp!=(Hensu *)0;hp=hp->next){
	if(hp->next!=NULL){
	  if(strcmp(var,(hp->next)->name)==0){
		hp->next=(hp->next)->next;
		return ;
	  }
	}
  }
}





/*
  $B<+J,$G:n@.$7$?(Bisdigit$BEy(B
   -1$B$+$i(B255$B0J30$N?t$KBP$7$F$O(B
   isdigit...$B$O@5>o$KF0$+$J$$(B
*/


int myisdigit(int c)
{
  if(c>='0' && c<='9')
	return 1;
  else 
	return 0;
}


int myisupper(int c)
{
  if(c>='A' && c<='Z')
	return 1;
  else 
	return 0;  
}


int myislower(int c)
{
  if(c>='a' && c<='z')
	return 1;
  else 
	return 0;    
}


int myisalpha(int c)
{
  if(myislower(c) || myisupper(c))
	return 1;
  else 
	return 0; 
}


int myisalnum(int c)
{
  if(myisdigit(c) || myisalpha(c))
	return 1;
  else 
	return 0;  
}


