%{
  #include "../common_file/tfb2any.h"
  extern unsigned int buffersize;
%}

%union{   /* type of yylval */
  int narg;   /* number of args */
  Symbol *sym; /* pointer to symbol */
}

/*
  $B;n:nIJ(B:tfb($BCf4V8@8l(B)$B$O$[$\(BAsir$B$HF1$8J8K!!#(B
  $B4X?t$NA0$K$O$I$N%=%U%H$N4X?t$G$"$k$+$H$$$&0u$,$D$/!#(Basir@sin(X);
  $BBgJ8;z$+$i;O$^$k1Q?t;zNs(B->$BJQ?t(B   $B%W%m%0%i%_%s%0$G$NJQ?t$N$3$H(B
  $B>.J8;z$+$i;O$^$k1Q?t;zNs(B->$BITDj85(B $BB?9`<0$NJQ?t$N$3$H(B
*/

%start list    /* $B%G%U%)%k%H$G$O(B1$BHV>e$N5,B'$+$i;O$^$k$N$G$3$l$O$J$/$F$b$h$$(B */
%token<sym> NUMBER VAR HUTEIGEN STRING /*HUTEIGEN:$BITDj85!J?t3X$G$NJQ?t(B)*/  
%token<sym> FUNCTION PREVIOUS CONST /* VAR:$B%W%m%0%i%_%s%0$G$NJQ?t(B */
%token<sym> MODULE /* $B%b%8%e!<%k4X?t8F$S=P$7(B*/
%token ROW MATRIX /* $B9TNs$N9T(B,$B9TNs(B */
%token RANGE RANGEST    /* step$BIU$-HO0O(B */
%token VECTOR COLUMN /* $B;H$o$J$$(B */
%token SET /* $B=89g(B */
%token DP   /* $BJ,;6I=8=B?9`<0(B*/
%token PARENS LIST OPE ASSIGN      /* $B>.3g8L$HBg3g8L$H1i;;;R$HBeF~1i;;;R(B */
%token ELEMENT            /* $BMWAGCj=P$N:]$NJQ?t(B  */
%token FUNCTIONELEMENT    /* $B4X?t8F$S=P$7$N$"$H$KMWAGHV9f$,$D$$$?>l9g(B */
%token DUMMYCOMMA       /* $B%@%_!<$N?F(B */
%type<sym> expr asgn range
%type<narg> datalist index end


%right '='
%left EQ    /* ==$B$N$3$H!'J}Dx<0(B */
%left '+' '-'
%left '*' '/'
%left '%'
%left UNARYMINUS UNARYPLUS   /* $BC19`%^%$%J%9(B,$B%W%i%9(B */
%right '^'
%%


list:   /* nothing */
| list end
| list expr end  {print_expr(); printend($3);}
| list asgn end  {print_expr(); printend($3);}
| list error end {yyerrok;}
;

end: ';' {$$=0;}
| '$'    {$$=1;}
;

/***************
NUMBER:$B?t;z(B
VAR:$BJQ?t(B
HUTEIGEN:$BITDj85(B
STRING:$BJ8;zNs(B
CONST:$BDj?t(B
PREVIOUS:$BA02s$NEz$((B
***************/

expr: NUMBER {push($1); $$=$1;} 
| VAR        {push($1); $$=$1;}
| HUTEIGEN   {push($1); $$=$1;}
| STRING     {push($1); $$=$1;}
| CONST      {push($1); $$=$1;} 
| PREVIOUS   {push($1); $$=$1;} 
| FUNCTION '(' datalist ')' {$$=makefunc($1,$3);}
| FUNCTION '(' datalist ')' index {$$=makefunc_elem($1,$3,$5);}
| MODULE '(' datalist ')' {$$=makefunc($1,$3);}
| '(' expr ')' {$$=kakko();}
| expr '+' expr {$$=add();}
| expr '-' expr {$$=sub();}
| expr '*' expr {$$=mul();}
| expr '/' expr {$$=divide();}
| expr '^' expr {$$=power();}
| expr '%' expr {$$=mod();}
| expr EQ expr {$$=make_eq();}    /* $BJ}Dx<0(B */
| '-' expr   %prec UNARYMINUS {$$=unaryminus();} 
| '+' expr   %prec UNARYPLUS  {$$=unaryplus();}
| '[' datalist ']' {$$=makelist($2);}  /* list or vector */ 
| '{' datalist '}' {$$=makeset($2);}   /* set */
| '<' '<' datalist '>' '>' {$$=make_duplicate_poly($3);} /* $BJ,;6I=8=B?9`<0(B */
| VAR index {$1->type=ELEMENT;$$=make_element($1,$2);} /* $BMWAG$N<h$j=P$7(B */
;


index: '[' expr ']'  {$$=1;} /* $BE:;z72(B */
| index '[' expr ']' {$$=$1+1;}  /* [1][2]$B$J$I$N9MN8(B */
;


range: expr RANGE expr {$$=makerange();}
| expr RANGE expr ':' expr {$$=makerangestep();}
;


asgn: HUTEIGEN '=' expr  {$1->type=VAR;install($1->value);$$=assignment($1);}
| VAR '=' expr {$$=assignment($1);}   /* $BJQ?t$X$NBeF~(B */
| VAR index '=' expr {$1->type=ELEMENT;$$=element_assign($1,$2,$4);} 
                   /*$BMWAG$X$NBeF~(B*/
| FUNCTION '(' datalist ')' index '=' expr  /* $B$-$D$$$+$J!#!#(B */
                     {$1->type=FUNCTION;$$=func_elem_assign($1,$3,$5,$7);}
| HUTEIGEN '=' range  {Symbol *tmp=assignment($1); install_rangevar($1->value,tmp); $$=tmp;}  /* range$B%j%9%H$KEPO?(B */
| VAR '=' range {Symbol *tmp=assignment($1);$1->type=HUTEIGEN;var_remove($1->value);install_rangevar($1->value,tmp);$$=tmp;}  /* $BITDj85%j%9%H$+$i30$7$F(Brange$B%j%9%H$KEPO?(B */   
;


/* $B0z?t$d%j%9%H$J$I$G$N%G!<%?$N%j%9%H(B */
datalist:  {$$=0;}  /* nothing */ 
| asgn     {$$=1;}
| expr     {$$=1;}   
| datalist ','  expr {$$=$1+1;}
| datalist ',' asgn {$$=$1+1;} 
;
%%
/* end of grammer */


#include<stdio.h>
#include<stdlib.h>
#include<ctype.h>
#include<setjmp.h>
#include<string.h>
char *progname;
extern int matrix_flag;
int lineno=1;    /* for error message */
jmp_buf begin;
unsigned int buffersize=0x100000; /* $B%P%C%U%!%5%$%:(B:default 1Mbyte:1048576$B7e(B $B:GBg$G(B4294967295$B7e(B */
short target=MATH;    /* $BJQ49$7$?$$?t3X%=%U%H(B */
int matrix_flag=0;

main(int argc,char *argv[])
{
  int i;
  for(i=1;i<argc;i++){
	if(strcmp("--buffersize",argv[i])==0)
	  buffersize=atoi(argv[i+1]);   /* default$BCM$NJQ99(B */
	if(strcmp(argv[i],"--matrix")==0)
	  matrix_flag=1;  /* $B9TNs2r<a%U%i%0(B  */
  }
  progname=argv[0];
  setjmp(begin);
  yyparse();
}


int yyerror(char *s) /* call from yyparse when syntax error exists */
{
  warning(s,(char *)0);
}


int warning(char *s,char *t)
{
  fprintf(stderr,"%s: %s",progname,s);
  if(t!=0)
	fprintf(stderr,"%s",t);
  fprintf(stderr," near line %d\n",lineno);
}


void execerror(char *s,char *t)
{
  warning(s,t);
  init();
  longjmp(begin,0);
}


void execerror2(char *s,char *t,char *u)   /* $B%(%i!<%a%C%;!<%8$rA}$d$7$?$$(B */
{
  fprintf(stderr,"%s: %s" ,progname,s);
  if(t!=0)
	fprintf(stderr,"%s",t);
  if(u!=0)
	fprintf(stderr," %s",u);
  fprintf(stderr," near line %d\n",lineno);
  init();
  longjmp(begin,0);
}

